function out=diag(in,K)
if isempty(in),out=in;return;end

precision=in(1).precision;
zero=mp(0,precision);
if nargin==1,K=0;end
s=size(in);
switch min(s)
    case 1 
        %The input is a vector, either row or column
        %The output must be a square matrix
        N=length(in)+abs(K);
        out=repmat(zero,N,N);
        SS.type='()';
        if K<=0
            SS.subs={(1-K):(N+1):(N*N)};
        else
            SS.subs={((1-K)+N+1):(N+1):(N*N)};
        end
        out=subsasgn(out,SS,in);
    otherwise 
        %The input is a matrix
        %The output is a column vector, or an empty one
        out=zero*[];
        for ii=1:size(in,1)
            if (ii+K)<=size(in,2)
                %Force column vector
                out(ii,1)=in(ii,(ii+K));
            end
        end
end
