function [y,Zf] = filter(b,a,x,Zi,DIM)
switch nargin
    case 3
        [y,Zf] = mvfilter(mp(b),mp(a),mp(x));
    case 4
        [y,Zf] = mvfilter(mp(b),mp(a),mp(x),mp(Zi));
    case 5
        error('Unimplemented yet!')
    otherwise
        error('Wrong number of parameters to @mp\filter.m')
end

% function [y,Zf] = filter(b,a,x,Zi,DIM)
% % Back-translated to matlab from an ANSI C implementation of MATLAB FILTER.M (built-in)
% % Written by Chen Yangquan <elecyq@nus.edu.sg>
% % By CLV, Nov 2006
% 
% if nargin>3
%     error('unimplemented yet!')
% else
%     Zf=NaN;%Do not know what to put here anyway...
%     ord=length(b)-1;
%     np=length(x)-1;
%     zero=x(1)*a(1)*b(1)*0;%Inherit the mp-class from somewhere...
%     y=repmat(zero,np+1,1);
%     y(0+1)=b(0+1)*x(0+1);
%     for i=1:ord
%         y(i+1)=zero;
%         for j=0:i
%             y(i+1)=y(i+1)+b(j+1)*x(i-j+1);
%         end
%         for j=0:(i-1)
%             y(i+1)=y(i+1)-a(j+1+1)*y(i-j-1+1);
%         end
%     end%/* end of initial part */
%     for i=(ord+1):np
%         y(i+1)=zero;
%         for j=0:ord
%             y(i+1)=y(i+1)+b(j+1)*x(i-j+1);
%         end
%         for j=0:(ord-1)
%             y(i+1)=y(i+1)-a(j+1+1)*y(i-j-1+1);
%         end
%     end
% end%/* end of filter */
% 
% % /*
% % FILTER.C
% % An ANSI C implementation of MATLAB FILTER.M (built-in)
% % Written by Chen Yangquan <elecyq@nus.edu.sg>
% % 1998-11-11
% % */
% % #include<stdio.h>
% % #define ORDER 3
% % #define NP 1001
% % 
% % /*
% % void filter(int,float *,float *,int,float *,float *);
% % */
% % filter(int ord, float *a, float *b, int np, float *x, float *y)
% % {
% %     
% %     int i,j;
% %     y[0]=b[0]*x[0];
% %     for (i=1;i<ord+1;i++)
% %         {
% %             y[i]=0.0;
% %             for (j=0;j<i+1;j++)
% %                 y[i]=y[i]+b[j]*x[i-j];
% %                 for (j=0;j<i;j++)
% %                     y[i]=y[i]-a[j+1]*y[i-j-1];
% %                 }
% %                 /* end of initial part */
% %             for (i=ord+1;i<np+1;i++)
% %                 {
% %                     y[i]=0.0;
% %                     for (j=0;j<ord+1;j++)
% %                         y[i]=y[i]+b[j]*x[i-j];
% %                         for (j=0;j<ord;j++)
% %                             y[i]=y[i]-a[j+1]*y[i-j-1];
% %                         }
% %                     } /* end of filter */