if ispc
    %some prerrequisites for COMPILATION (not execution!):
    %  MinGW
    %  gmp.dll as provided
    %  mpfr.dll as provided
    %  libgmp-3.dll as provided (is identical to gmp.dll!)
    
    MinGWbin='e:\MinGW\bin'; %no slash at the end!
    %check that the user has edited the above constant
    d=dir([MinGWbin '\gcc.exe']);
    if isempty(d)
        disp(['MinGW is not located at ' strrep(MinGWbin,'\bin','')])
        error(['Edit this file according to your setup, and run this again'])
    end
    MATLABROOT=strrep(which('matlabrc'),'\toolbox\local\matlabrc.m','');
    if ~isdir('bin'),S=mkdir('.','bin');end
    if ~isdir('bin\win32'),S=mkdir('.','bin\win32');end
    dd=dir('.\bin\win32\*.dll');
    if isempty(dd)
        switch version('-release')
            case {'2006a' '13'}
                %compiled for 13 and 7.2, under W2K, and tested also under XP (but no compilation!)
                PWD=pwd;cd([MATLABROOT '/bin/win32/']);
                dos([MinGWbin '\dlltool -D libmex.dll -l libmex.a -d ../../extern/include/libmex.def']);
                dos([MinGWbin '\dlltool -D libmat.dll -l libmat.a -d ../../extern/include/libmat.def']);
                dos([MinGWbin '\dlltool -D libmx.dll -l libmx.a -d ../../extern/include/libmx.def']);
                dos(['copy libmex.* ' PWD ]);
                dos(['copy libmat.* ' PWD ]);
                dos(['copy libmx.* ' PWD ]);
            otherwise
                disp(['This version has not been tested before. Edit this file to try'])
                error(['and report it to the author if you succeed in compile it'])
        end
        cd(PWD)
    end
    
    dd=dir;
    
    for ii=1:length(dd)
        if length(dd(ii).name)>2
            if strcmpi(dd(ii).name(end-1:end),'.c') & isempty(strfind(dd(ii).name,'atan2'))
                disp(['compiling: ' dd(ii).name])
                %We are not using mex, so on principle gnumex is not required
                txt=['!' MinGWbin '\gcc -g -O2 -shared -fexceptions -o' strrep(dd(ii).name,'.c','.dll') ...
                        ' -I..\..\..\..\extern\include -I. -L..\..\..\..\bin\win32 ' dd(ii).name ...
                        ' gmp.dll mpfr.dll -lmat -lmex -lmx -lm'];     
                disp(txt);eval(txt);
            end % if strcmpi(dd(ii).
        end % if length(dd(ii).
    end % for ii=1:length(dd)
else %is unix!
    dd=dir;
    
    for ii=1:length(dd)
        if length(dd(ii).name)>2
            if strcmpi(dd(ii).name(end-1:end),'.c') & isempty(strfind(dd(ii).name,'atan2'))
                disp(['compiling: ' dd(ii).name])
                mex([dd(ii).name,' mpfr_atan2.c'],'-lmpfr -lgmp');
            end % if strcmpi(dd(ii).
        end % if length(dd(ii).
    end % for ii=1:length(dd)
    
end
