%pack_mp: packs a zip file with all the necessary files for deploying the mp toolbox
%defaulting to a specific release

PWD=pwd;MATLABROOT=strrep(which('matlabrc'),'\toolbox\local\matlabrc.m','');
lista={'toolbox\NewClasses\set_mp_defaults.m' ...
        'toolbox\NewClasses\pack_mp.m' ...
        'toolbox\NewClasses\mp*.m' ...
        'toolbox\NewClasses\mp_README.txt' ...
        'toolbox\NewClasses\my*.m' ...
        'toolbox\NewClasses\mvfilter.m' ...
        'toolbox\NewClasses\gauss*.m' ...
        'toolbox\NewClasses\dvec_sort_bubble_a.m' ...
        'toolbox\NewClasses\@mp' ...
        'bin\win32\gmp.dll' 'bin\win32\mpfr.dll' 'bin\win32\libgmp-3.dll'};
MATLABROOT6p5='c:\matlab6p5';
%check that the directory agrees with the source one, namely for R13
if ~strcmp(MATLABROOT,MATLABROOT6p5) %for anyone except R13 itself
    if exist(MATLABROOT6p5,'dir')
        try,warning('off','MATLAB:DeprecatedLogicalAPI'),end
        cd(MATLABROOT6p5);
        %check against the original source
        for i=1:length(lista)
            d=dir(lista{i});
            prefijo=fileparts(lista{i});
            %Esto falla cuando hay directorios del tipo @mp;
            if ~isempty(findstr(lista{i},'@mp')),prefijo=[prefijo filesep '@mp'];end
            j1=1;if strcmp(d(1).name,'.'),j1=3;end
            for j=j1:length(d)
                d6p5=dir([MATLABROOT6p5 filesep prefijo filesep d(j).name]);
                dcurrent=dir([MATLABROOT filesep prefijo filesep d(j).name]);
                if isempty(dcurrent) %falta el homlogo!
                    [pathstr,nam,ext]=fileparts(d(j).name);
                    switch lower(ext)
                        case {'.m' '.dll' '.txt'}
                            disp(['copiaremos el archivo ' d(j).name])
                            %lo copiamos
                            dos(['copy ' MATLABROOT6p5 filesep prefijo filesep d(j).name ' ' ...
                                MATLABROOT filesep prefijo filesep d(j).name]);
                        otherwise
                            %do not care...
                            %disp(['FALT el archivo ' d(j).name])
                    end
                else %el homlogo existe, pero hay que ver si a) es igual o b) es ms nuevo
                    if ~d(j).isdir
                        if d6p5.bytes ~= dcurrent.bytes
                            %disp(['los archivos no tienen el mismo tamao:' d(j).name])
                            dos(['copy ' MATLABROOT6p5 filesep prefijo filesep d(j).name ' ' ...
                                MATLABROOT filesep prefijo filesep d(j).name]);
                        else
                            %tienen el mismo tamao; veremos si son idnticos
                            try
                                md5_6p5=md5checksum([MATLABROOT6p5 filesep prefijo filesep d(j).name],1);
                                if md5checksum([MATLABROOT filesep prefijo filesep d(j).name], 1, md5_6p5)
                                    %disp(['files are identical:' d(j).name])
                                else
                                    %disp(['los archivos no son identicos:' d(j).name])
                                    dos(['copy ' MATLABROOT6p5 filesep prefijo filesep d(j).name ' ' ...
                                            MATLABROOT filesep prefijo filesep d(j).name]);
                                    end
                                end
                        end
                    end
                end
            end
        end
    end
end
cd(MATLABROOT);
zipfile=['mpWindows' version('-release') '.zip'];
if exist(zipfile)==2,delete(zipfile);end;
zip(zipfile,lista);
%collect also the binaries
lista={'toolbox\NewClasses\@mp\private\*.dll' };
zipfile=['mpWindowsBinaries' version('-release') '.zip'];
if exist(zipfile)==2,delete(zipfile);end;
zip(zipfile,lista);
cd(PWD)
